# gui.py
# basiert auf Demo_mit_StaticText&TextCtrl_ENTER.py

import wx

from raumplanerModell import RaumplanerModell

### ---------------------------------------------------
class Gui(wx.Frame):
    def __init__(
            self, parent, ID, title, pos=(500,50), # neu
            size=(400,570), style=wx.DEFAULT_FRAME_STYLE
            ):

        wx.Frame.__init__(self, parent, ID, title, pos, size, style)
        self.__modell = None
        panel = wx.Panel(self, -1)

        ### Menu-Abschnitt
        # Prepare the menu bar
        menuBar = wx.MenuBar()

        # erstes Menue
        dateiMenu = wx.Menu()
        dateiMenu.Append(101, "Oeffnen")
        dateiMenu.Append(102, "Speichern")
        dateiMenu.AppendSeparator()
        dateiMenu.Append(103, "Beenden")
        # Add menu to the menu bar
        menuBar.Append(dateiMenu, "Datei")

        # zweites Menue
        neuMenu = wx.Menu()
        neuMenu.Append(201, "Stuhl", "")
        neuMenu.Append(202, "Tisch", "")
        neuMenu.Append(203, "Schrank", "")
        ##neuMenu.AppendSeparator()
        # Add menu to the menu bar
        menuBar.Append(neuMenu, "&Moebel")
        
        self.SetMenuBar(menuBar)

        ### Menu events
        self.Bind(wx.EVT_MENU, self.OnOeffnen, id=101)
        self.Bind(wx.EVT_MENU, self.OnSpeichern, id=102)
        self.Bind(wx.EVT_MENU, self.OnBeenden, id=103) ## Korrektur

        self.Bind(wx.EVT_MENU, self.OnStuhl, id=201)
        self.Bind(wx.EVT_MENU, self.OnTisch, id=202)
        self.Bind(wx.EVT_MENU, self.OnSchrank, id=203)


        gbs = self.gbs = wx.GridBagSizer(vgap=5, hgap=5)

        ### Label und TextCtrl
        self.labelAusgewaehlt = wx.StaticText(panel, -1, "ausgewählt ist keines")
        gbs.Add(self.labelAusgewaehlt, (0,0), flag=wx.ALL, border=10)

        self.labelX = wx.StaticText(panel, -1, "x-Position")
        gbs.Add(self.labelX, (1,0), flag=wx.ALL, border=10)
        self.textCtrlX = wx.TextCtrl(panel, -1,
                                     "",
                                     size=(205, -1),
                                     style=wx.TE_PROCESS_ENTER) ## wichtig!!!
        gbs.Add(self.textCtrlX, (1,1), flag=wx.ALL, border=10)
        self.Bind(wx.EVT_TEXT_ENTER, self.OnTextEnter, self.textCtrlX)

        self.labelY = wx.StaticText(panel, -1, "y-Position")
        gbs.Add(self.labelY, (2,0), flag=wx.ALL, border=10)
        self.textCtrlY = wx.TextCtrl(panel, -1,
                                     "",
                                     size=(205, -1),
                                     style=wx.TE_PROCESS_ENTER) ## wichtig!!!
        gbs.Add(self.textCtrlY, (2,1), flag=wx.ALL, border=10)
        self.Bind(wx.EVT_TEXT_ENTER, self.OnTextEnter, self.textCtrlY)

        self.labelB = wx.StaticText(panel, -1, "Breite")
        gbs.Add(self.labelB, (3,0), flag=wx.ALL, border=10)
        self.textCtrlB = wx.TextCtrl(panel, -1,
                                     "",
                                     size=(205, -1),
                                     style=wx.TE_PROCESS_ENTER) ## wichtig!!!
        gbs.Add(self.textCtrlB, (3,1), flag=wx.ALL, border=10)
        self.Bind(wx.EVT_TEXT_ENTER, self.OnTextEnter, self.textCtrlB)

        self.labelT = wx.StaticText(panel, -1, "Tiefe")
        gbs.Add(self.labelT, (4,0), flag=wx.ALL, border=10)
        self.textCtrlT = wx.TextCtrl(panel, -1,
                                     "",
                                     size=(205, -1),
                                     style=wx.TE_PROCESS_ENTER) ## wichtig!!!
        gbs.Add(self.textCtrlT, (4,1), flag=wx.ALL, border=10)
        self.Bind(wx.EVT_TEXT_ENTER, self.OnTextEnter, self.textCtrlT)

        self.labelW = wx.StaticText(panel, -1, "Winkel")
        gbs.Add(self.labelW, (5,0), flag=wx.ALL, border=10)
        self.textCtrlW = wx.TextCtrl(panel, -1,
                                     "",
                                     size=(205, -1),
                                     style=wx.TE_PROCESS_ENTER) ## wichtig!!!
        gbs.Add(self.textCtrlW, (5,1), flag=wx.ALL, border=10)
        self.Bind(wx.EVT_TEXT_ENTER, self.OnTextEnter, self.textCtrlW)

        self.labelF = wx.StaticText(panel, -1, "Farbe")
        gbs.Add(self.labelF, (6,0), flag=wx.ALL, border=10)
        self.textCtrlF = wx.TextCtrl(panel, -1,
                                     "",
                                     size=(205, -1),
                                     style=wx.TE_PROCESS_ENTER) ## wichtig!!!
        gbs.Add(self.textCtrlF, (6,1), flag=wx.ALL, border=10)
        self.Bind(wx.EVT_TEXT_ENTER, self.OnTextEnter, self.textCtrlF)

        self.labelH = wx.StaticText(panel, -1, "Änderung mit ENTER abschließen")
        gbs.Add(self.labelH, (7,1), flag=wx.ALL, border=10)

        ### Button-Abschnitt
        waehleButton = wx.Button(panel, 1001, u"wähle")
        gbs.Add(waehleButton, (8,0), flag=wx.ALL, border=10)
        self.Bind(wx.EVT_BUTTON, self.OnWaehle, waehleButton)
        
        beendenButton = wx.Button(panel, 1003, "Beenden")
        gbs.Add(beendenButton, (8,1), flag=wx.ALL | wx.ALIGN_CENTER, border=10)
        self.Bind(wx.EVT_BUTTON, self.OnBeenden, beendenButton)
        ### Fensterereignis
        self.Bind(wx.EVT_CLOSE, self.OnCloseWindow)

        panel.SetSizerAndFit(gbs)

    def SetzeModell(self,modell):
        self.__modell = modell

    ### Ereignisbehandlung ###
    ### TextCtrl
    def OnTextEnter(self, event):
        ##print('Enter bei Inhalt "'+self.textCtrl1.GetValue()+'"')
        xT=self.textCtrlX.GetValue() # neu
        yT=self.textCtrlY.GetValue() # neu
        bT=self.textCtrlB.GetValue() # neu
        tT=self.textCtrlT.GetValue() # neu
        wT=self.textCtrlW.GetValue() # neu
        f=self.textCtrlF.GetValue() # ist String
        try:
            x=int(xT)
            y=int(yT)
            b=int(bT)
            t=int(tT)
            w=int(wT)
        except ValueError as e:
            return
        self.__modell.SetzeDaten(x,y,b,t,w,f)

##    def OnText(self, event):                      ## sinnvoll ??
##            pass
        
    ### Menu-Abschnitt
    def OnOeffnen(self, event):
        ##self.textCtrl1.SetValue('Oeffnen angeklickt')
        self.__modell.Lade('Daten/daten_1.dat')

    def OnSpeichern(self, event):
        ##self.textCtrl1.SetValue('Speichern angeklickt')
        self.__modell.Speichere('Daten/daten_1.dat')

    def OnStuhl(self, event):
        ##self.textCtrl1.SetValue('erzeuge Stuhl angeklickt')
        self.__modell.Neu('Stuhl', sichtbar=True)

    def OnTisch(self, event):
        ##self.textCtrl1.SetValue('erzeuge Tisch angeklickt')
        self.__modell.Neu('Tisch', sichtbar=True)

    def OnSchrank(self, event):
        ##self.textCtrl1.SetValue('erzeuge Schrank angeklickt')
        self.__modell.Neu('Schrank', sichtbar=True)


    ### Button-Abschnitt
    def OnWaehle(self, event):
        if len(self.__modell.GibAlleMoebel())==0:
            self.labelAusgewaehlt.SetLabel("ausgewählt ist keines")
            return # nichts auszuwählen
        self.__modell.Waehle() # neu
        x,y,b,t,w,f=self.__modell.GibDaten()
        self.textCtrlX.SetValue(str(x))
        self.textCtrlY.SetValue(str(y))
        self.textCtrlB.SetValue(str(b))
        self.textCtrlT.SetValue(str(t))
        self.textCtrlW.SetValue(str(w))
        self.textCtrlF.SetValue(f)
        if self.__modell.GibIndex()==-1:
            self.labelAusgewaehlt.SetLabel("ausgewählt ist keines")
            return # keines ausgewählt
        auswahl=self.NameKlasse(self.__modell.GibAusgewaehltes())
        auswahl+=' , Nummer '+str(self.__modell.GibIndex()+1)
        self.labelAusgewaehlt.SetLabel("ausgewählt ist "+auswahl)

    def NameKlasse(self, objekt):
        '''Hilfsfunktion für OnWaehle'''
        return str(objekt.__class__).partition('.')[2].partition("'")[0]
    
    def OnBeenden(self, event):
        self.Close(True)

    def OnCloseWindow(self, event):
        self.Destroy()

### ---------------------------------------------------
class RaumplanerApp(wx.App):
    """Anwendung fuer Raumplaner"""
    def OnInit(self):
        self.fenster = Gui(None, 1000, "Raumplaner")
        self.SetTopWindow(self.fenster)
        self.fenster.Show(True)
        return True

### ---------------------------------------------------
if __name__ == '__main__':
    app = RaumplanerApp(redirect=False)
    app.MainLoop()
